(*
Micrometer by Uri Fridman.
This code is released under the GPL, there are no warranties. Use at your own
risk. Please refer to the file COPYING.txt for more information
*)
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Gauges, ALProgressBar, Menus, CoolTrayIcon, inifiles,
  XPMan;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    ALProgressBar1: TALProgressBar;
    PopupMenu1: TPopupMenu;
    Options1: TMenuItem;
    Alwaysontop1: TMenuItem;
    About1: TMenuItem;
    CoolTrayIcon1: TCoolTrayIcon;
    Exit1: TMenuItem;
    ALProgressBar2: TALProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ALProgressBar3: TALProgressBar;
    Centermeter1: TMenuItem;
    Label7: TLabel;
    XPManifest1: TXPManifest;
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Alwaysontop1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Centermeter1Click(Sender: TObject);
  private
    { Private declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public declarations }
    transparency:boolean;
    transvalue:integer;
    checknet:boolean;
    fulltransparency:boolean;
    showclock:boolean;
  end;

function InetIsOffline(Flag: Integer): Boolean; stdcall; external 'URL.DLL';

const
  SystemBasicInformation = 0;
  SystemPerformanceInformation = 2;
  SystemTimeInformation = 3;

type
  TPDWord = ^DWORD;

  TSystem_Basic_Information = packed record
    dwUnknown1: DWORD;
    uKeMaximumIncrement: ULONG;
    uPageSize: ULONG;
    uMmNumberOfPhysicalPages: ULONG;
    uMmLowestPhysicalPage: ULONG;
    uMmHighestPhysicalPage: ULONG;
    uAllocationGranularity: ULONG;
    pLowestUserAddress: Pointer;
    pMmHighestUserAddress: Pointer;
    uKeActiveProcessors: ULONG;
    bKeNumberProcessors: byte;
    bUnknown2: byte;
    wUnknown3: word;
  end;

type
  TSystem_Performance_Information = packed record
    liIdleTime: LARGE_INTEGER; {LARGE_INTEGER}
    dwSpare: array[0..75] of DWORD;
 end;

type
  TSystem_Time_Information = packed record
    liKeBootTime: LARGE_INTEGER;
    liKeSystemTime: LARGE_INTEGER;
    liExpTimeZoneBias: LARGE_INTEGER;
    uCurrentTimeZoneId: ULONG;
    dwReserved: DWORD;
end;

var
  Form1: TForm1;
  NtQuerySystemInformation: function(infoClass: DWORD;
  buffer: Pointer;
  bufSize: DWORD;
  returnSize: TPDword): DWORD; stdcall = nil;
  liOldIdleTime: LARGE_INTEGER = ();
  liOldSystemTime: LARGE_INTEGER = ();

  
implementation

uses options, about;

{$R *.dfm}



procedure TForm1.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style AND NOT WS_CAPTION; //captionless
end;


function Li2Double(x: LARGE_INTEGER): Double;
begin
  Result := x.HighPart * 4.294967296E9 + x.LowPart
end;


procedure GetCPUUsage;
var
  SysBaseInfo: TSystem_Basic_Information;
  SysPerfInfo: TSystem_Performance_Information;
  SysTimeInfo: TSystem_Time_Information;
  status: Longint; {long}
  dbSystemTime: Double;
  dbIdleTime: Double;
  bLoopAborted : boolean;
begin
  if @NtQuerySystemInformation = nil then
    NtQuerySystemInformation := GetProcAddress(GetModuleHandle('ntdll.dll'),
      'NtQuerySystemInformation');

  // get number of processors in the system

  status := NtQuerySystemInformation(SystemBasicInformation, @SysBaseInfo, SizeOf(SysBaseInfo), nil);
  if status <> 0 then Exit;

  bLoopAborted := False;

    // get new system time
    status := NtQuerySystemInformation(SystemTimeInformation, @SysTimeInfo, SizeOf(SysTimeInfo), 0);
    if status <> 0 then Exit;

    // get new CPU's idle time
    status := NtQuerySystemInformation(SystemPerformanceInformation, @SysPerfInfo, SizeOf(SysPerfInfo), nil);
    if status <> 0 then Exit;

    // if it's a first call - skip it
    if (liOldIdleTime.QuadPart <> 0) then
    begin

      // CurrentValue = NewValue - OldValue
      dbIdleTime := Li2Double(SysPerfInfo.liIdleTime) - Li2Double(liOldIdleTime);
      dbSystemTime := Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(liOldSystemTime);

      // CurrentCpuIdle = IdleTime / SystemTime
      dbIdleTime := dbIdleTime / dbSystemTime;

      // CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
      dbIdleTime := 100.0 - dbIdleTime * 100.0 / SysBaseInfo.bKeNumberProcessors + 0.5;

      // Show Percentage
      Form1.Label1.Caption := FormatFloat('0 %',round(dbIdleTime));
      form1.ALProgressBar1.Position:=round(dbIdleTime);

      Application.ProcessMessages;
    end;

    // store new CPU's idle and system time
    liOldIdleTime := SysPerfInfo.liIdleTime;
    liOldSystemTime := SysTimeInfo.liKeSystemTime;

end;


function ShowNetworkStatus:boolean;
begin
  if InetIsOffline(0) then
   result:=false
  else
   result:=true;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
   Status:TMemoryStatus;
   NetStatus:boolean;
begin
   Status.dwLength := sizeof(TMemoryStatus);
   GlobalMemoryStatus(Status);
   label2.caption:=inttostr(Status.dwMemoryLoad)+ ' %';
   ALProgressBar2.Position:=Status.dwMemoryLoad;
   GetCPUUsage;
   if checknet then
   begin
     if ShowNetworkStatus then
     begin
       label6.Caption:='ON';
       ALProgressBar3.BarColor1:=clSilver;
       ALProgressBar3.BarColor2:=clSilver;
       ALProgressBar3.BarColor3:=clGreen;
     end
     else
     begin
       label6.Caption:='OFF';
       ALProgressBar3.BarColor1:=clSilver;
       ALProgressBar3.BarColor2:=clSilver;
       ALProgressBar3.BarColor1:=clRed;
     end;
   end;
   label7.Caption:=TimeToStr(now);
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
   close;
end;


procedure TForm1.Alwaysontop1Click(Sender: TObject);
begin
   if Alwaysontop1.Checked then
   begin
      form1.FormStyle:=fsNormal;
      Alwaysontop1.Checked:=false;
   end
   else
   begin
      form1.FormStyle:=fsStayOnTop;
      Alwaysontop1.Checked:=true;
   end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  Lpos:integer;
  Tpos:integer;
begin
  SetLayeredWindowAttributes(Handle, 0, 230, $00000002); // LWA_ALPHA

  label7.Caption:=TimeToStr(now);
  label7.Visible:=false;

  Form1.Width:=118;
  form1.Height:=47;

  transparency:=TRUE;
  transvalue:=175;
  checknet:=false;
  fulltransparency:=false;
  showclock:=false;
  
  if FileExists(extractfilepath(application.ExeName)+'\resource.ini') then
  begin
    IniFile := TIniFile.Create(extractfilepath(application.ExeName)+'\resource.ini');
    transparency:=IniFile.ReadBool('Options','Transparency',TRUE);
    transvalue:=IniFile.ReadInteger('Options','Value',175);
    Lpos:=IniFile.ReadInteger('Options','Lpos',Left);
    Tpos:=IniFile.ReadInteger('Options','Tpos',Top);
    checknet:=IniFile.ReadBool('Options','Net',FALSE);
    fulltransparency:=IniFile.ReadBool('Options','FullTransparency',FALSE);
    showclock:=IniFile.ReadBool('Options','Clock',FALSE);
    IniFile.Free;
    form1.Left:=Lpos;
    form1.Top:=Tpos;
    form1.AlphaBlend:=transparency;
    form1.AlphaBlendValue:=transvalue;
    form1.TransparentColor:=fulltransparency;
  end;

  ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE, getWindowLong(Application.Handle,
                GWL_EXSTYLE) or WS_EX_TOOLWINDOW);
  ShowWindow(Application.Handle, SW_SHOW);

end;


procedure TForm1.Options1Click(Sender: TObject);
begin
  form2.showmodal;
end;


procedure TForm1.About1Click(Sender: TObject);
begin
  form3.showmodal;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
    IniFile : TIniFile;
begin
    IniFile := TIniFile.Create(extractfilepath(application.ExeName)+'\resource.ini');
    IniFile.WriteBool('Options','Transparency',form2.CheckBox1.Checked);
    IniFile.WriteInteger('Options','Value',form2.TrackBar1.Position);
    IniFile.WriteInteger('Options','Lpos',form1.Left);
    IniFile.WriteInteger('Options','Tpos',form1.Top);
    IniFile.WriteBool('Options','Net',form2.CheckBox2.Checked);
    IniFile.WriteBool('Options','FullTransparency',form2.CheckBox3.Checked);
    IniFile.WriteBool('Options','Clock',form2.CheckBox4.Checked);
    IniFile.Free;
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
  SC_DRAGMOVE = $F012;
begin
  if Button = mbLeft then
  begin
    ReleaseCapture;
    Perform(WM_SYSCOMMAND, SC_DRAGMOVE, 0);
  end;
end;


procedure TForm1.Centermeter1Click(Sender: TObject);
begin
   Form1.Left := (Screen.Width - Form1.Width) div 2;
   Form1.Top := (Screen.Height - Form1.Height) div 2;
end;

end.
